#ifndef _MY_DX_8_0__WRAPPER__DEFINES__21_JULY_2001__
#define	_MY_DX_8_0__WRAPPER__DEFINES__21_JULY_2001__

#include <Windows.h>
#include <tchar.h>
#include <math.h>
#include <ddraw.h>
#include <DInput.h>
#include <d3d8.h>
#include <d3d8types.h>


#define e_xit	{ res=FALSE ; goto xit ; }
#define ERXIT	e_xit


//	rand( low,high )
#define	RAND_INT( a,b )	((a)+(rand()%((b)-(a)+1)))

//////////		Freeing of Heap, Handles, COM interfaces	//////////////
#define	SAFE_RELEASE(ptr)	if((ptr))	(ptr)->lpVtbl->Release((ptr)) , (ptr) = 0 ;

#define	SAFE_CLOSEHANDLE(handle)	if((handle!=0)&&(handle!=INVALID_HANDLE_VALUE)) \
							CloseHandle((handle)), (handle) = 0 ;
///////////////////////////////////////////////////////////////////////////


///////////////////////// COLOR related	/////////////////////////////////////
#define DORGB(r,g,b) (D3DCOLOR_XRGB((r),(g),(b)))
#define DORGBA(r,g,b,a) (D3DCOLOR_RGBA((r),(g),(b),(a)))
#define DOARGB(r,g,b,a) (D3DCOLOR_ARGB((a),(r),(g),(b)))
#define GetRandomColor()	(DORGB(RAND_INT(30,250), RAND_INT(20,250), RAND_INT(10,200)))

////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////// Angles and rasians	///////////////////////////////////
#define THIS_APP_PI 3.14159265358979323846f

#define RADIANS(x)	((float)(x) * (THIS_APP_PI/180.0f))
#define DEGREES(x)  ((float)(x) * (180.0f/THIS_APP_PI))
////////////////////////////////////////////////////////////////////////////////////////


//////////////////	string compare defines	//////////////////////////////////////////////////////
#define STRING_TRUE_OR_FALSE_CMP(valueTocheckWith,valueTocheck)	(((valueTocheck)==(valueTocheckWith)) ? _T("TRUE") : _T("FALSE"))
#define STRING_TRUE_OR_FALSE(booleanValue)	((booleanValue) ? _T("TRUE") : _T("FALSE"))
//////////////////////////////////////////////////////////////////////////////////////////



//////////////////	Direct3d Shortnames		////////////////////////////
#define BEGINSCENE(edPtr)	(*(edPtr)).device8->lpVtbl->BeginScene((*(edPtr)).device8) ;
#define	ENDSCENE(edPtr)		(*(edPtr)).device8->lpVtbl->EndScene((*(edPtr)).device8) ;


#define DRAWP(device8, primType, startVertex, numVertices)	\
		(device8)->lpVtbl->DrawPrimitive((device8), (primType), (startVertex), (numVertices)) ;

#define DRAWIP(device8, primType, MinIndex, NumVertices, StartIndex, PrimitiveCount) \
		(device8)->lpVtbl->DrawIndexedPrimitive((device8), (primType), (MinIndex), (NumVertices), (StartIndex), (PrimitiveCount)) ;

#define	SETLIGHT(device8, index,ONorOFF)	(device8)->lpVtbl->LightEnable((device8), \
															(index),(ONorOFF)) ;

#define SETRENDERSTATE(device8, state, val) ((device8)->lpVtbl->SetRenderState((device8), \
									(state), (val)))

#define SETLIGHTSTATE(device8, ONorOFF)	SETRENDERSTATE(device8, D3DRS_LIGHTING, (ONorOFF)) ;

#define SETTRANSFORM(device8, state, matrix) \
		(device8)->lpVtbl->SetTransform((device8), (state), (matrix)) ;

#define SETTEXTURE(device8, stage, tex) (device8)->lpVtbl->SetTexture((device8), (stage), (IDirect3DBaseTexture8*)(tex)) ;

#define SETTEXTURESTAGE(device8, stage, state, value) \
		(device8)->lpVtbl->SetTextureStageState((device8), (stage), (state), (value)) ;

#define SETSTREAMSOURCE(device8, StreamNumber, pVertexBuffer, Stride)\
		(device8)->lpVtbl->SetStreamSource((device8), (StreamNumber), (pVertexBuffer), (Stride)) ;

#define SETVERTEXSHADER(device8, ShaderHandle) (device8)->lpVtbl->SetVertexShader((device8), (ShaderHandle)) ;

#define SETINDICES(device8, pIndexBuffer, BaseVertexIndex) (device8)->lpVtbl->SetIndices((device8), (pIndexBuffer), (BaseVertexIndex)) ;

//////////////////////////////////////////////////////////////////////////////////////////

////////////////////////	Direct Input	///////////////////////////////////////////////
#define DIKEYDOWN(data, key) (data[(key)] & 0x80)
#define SAFE_ACQUIRE(device) if(device) device->lpVtbl->Acquire(device) ;
#define SAFE_UNACQUIRE(device) if(device) device->lpVtbl->Unacquire(device) ;
//////////////////////////////////////////////////////////////////////////////////////////


#define TURNLIGHTON(device8)	{	SETLIGHTSTATE(device8, TRUE) ;\
									SETTEXTURESTAGE(device8, 0, D3DTSS_COLOROP, D3DTOP_MODULATE) ; }
#define TURNLIGHTOFF(device8)	{	SETLIGHTSTATE(device8, FALSE) ;\
									SETTEXTURESTAGE(device8, 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1) ; }

#endif	_MY_DX_8_0__WRAPPER__DEFINES__21_JULY_2001__